Guidelines for Charactering "OAM"
Carlos Pignataro
North Carolina State University
US
cpignata@gmail.com
cmpignat@ncsu.edu
Adrian Farrel
Old Dog Consulting
UK
adrian@olddog.co.uk
Ops Area
OPS Area Working Group
As the IETF continues to produce and standardize different Operations, Administration, and Maintenance (OAM) protocols and technologies, various qualifiers and modifiers are prepended to the OAM abbreviation. While, at first glance, the most used appear to be well understood, the same qualifier may be interpreted differently in different contexts. A case in point is the qualifiers "in-band" and "out-of-band" which have their origins in the radio lexicon, and which have been extrapolated into other communication networks.
This document considers some common qualifiers and modifiers that are prepended, within the context of packet networks, to the OAM abbreviation and lays out guidelines for their use in future IETF work.
This document updates RFC 6291 by adding to the guidelines for the use of the term "OAM".

Introduction
It is not uncommon for historical and popular terms to have nuances in how they are interpreted or understood. This was, for example, the case with the abbreviation for Operations, Administration, and Maintenance, "OAM", and [RFC6291] provided guidelines for its use as well as definitions of its constituent parts.
Characterizations or qualifiers for "OAM" within packet networks often encounter similar problems of interpretation, such as with the adjective phrases "in-band" and "out-of-band". This document considers some common qualifiers and modifiers that are prepended to the OAM abbreviation, and lays out guidelines for their use in future IETF work to achieve unambiguous characterization.
Additionally, this document recommends avoiding the creation and use of extended abbreviation for the qualifiers of "OAM". For example, the first "O" in "OOAM" could mean out-of-band, overlay, or something else.
This document updates [RFC6291] by adding to the guidelines for the use of the term "OAM".
Note that [RFC7799] defines terms for active and passive performance assessments through metrics and methods. That RFC does not substantially discuss OAM, and although the concepts are similar, this document does not modify the definitions in [RFC7799].

In-Band and Out-of-Band OAM
Historically, the terms "in-band" and "out-of-band" were used extensively in radio communications as well as in telephony signaling [RFC4733]. In both these cases, there is an actual "Band" (i.e., a "Channel" or "Frequency") to be within or outside.
While those terms, useful in their simplicity, continued to be broadly used to mean "within something" and "outside something", a challenge is presented for IP communications and packet switch networks (PSNs) which do not have a "band" per se, and, in fact, have multiple "somethings" that OAM can be carried within or outside. A frequently encountered case is the use of "in-band" to mean either in-packet or on-path.
Within the IETF, the terms "in-band" and "out-of-band" cannot be reliably understood consistently and unambiguously. Context-specific redefinitions of these terms cannot be generalized and can be confused by participants from other contexts. More importantly, the terms are not self-defining to any further extent and cannot be understood by someone exposed to them for the first time, since there is no "band" in IP.
The guidance in this document is to avoid the terms "in-band" and "out-of-band", and instead find finer-granularity descriptive terms. The definitions presented in this document are for use in all future IETF documents that refer to OAM, and the terms "in-band OAM" and "out-of-band OAM" are not to be used in future documents.
Path: OAM in relation to a path.
  Path-Congruent OAM:
The OAM information follows the exact same path as the observed data traffic. This was sometimes referred to as "in-band".
  Non-Path-Congruent OAM:
The OAM information does not follow the same path as the observed data traffic. This was sometimes referred to as "out-of-band".
[RFC6669] gives an example of "Path-Congruent OAM", and further describes that the OAM Packets "share their fate with data packets."
Packet: OAM in relation to a user data packet.
  In-Packet OAM:
The OAM information is carried in the packets that also carry the data traffic. This was sometimes referred to as "in-band".
  Dedicated-Packet OAM:
The OAM information is carried in its own OAM packets, separate from data traffic. This was sometimes referred to as "out-of-band".
The MPLS echo request/reply messages [RFC8029] are an example of "Dedicated-Packet OAM", since they are described as "An MPLS echo request/reply is a (possibly MPLS-labeled) IPv4 or IPv6 UDP packet".
In situ OAM [RFC9197] is an example of "In-Packet OAM", given that it: '...records OAM information within the packet while the packet traverses a particular network domain. The term "in situ" refers to the fact that the OAM data is added to the data packets rather than being sent within packets specifically dedicated to OAM.'
Initially, "in situ OAM" [IETF96-In-Band-OAM] was also referred to as "In-band OAM", but was renamed due to the overloaded meaning of "in-band OAM". Further, [RFC9232] also intertwines the terms "in-band" with "in situ", though [I-D.song-opsawg-ifit-framework] settled on using "in Situ". Other similar uses, including [P4-INT-2.1] and [I-D.kumar-ippm-ifa], still use variations of "in-band", "in band", or "inband".
It is noteworthy that In-Packet OAM cannot be Non-Path-Congruent OAM.
Packet Treatment: OAM in relation to the treatment of user data packets, as for example QoS treatment.
  Equal-QoS-Treatment OAM:
The OAM packets receive the same QoS treatment as user data packets. This was sometimes referred to as "in-band".
  Different-QoS-Treatment OAM:
The OAM packets receive different QoS treatment as user data packets. This was sometimes referred to as "out-of-band".
For a case of either "Non-Path-Congruent OAM" or "Different-QoS-Treatment OAM", [I-D.ietf-detnet-oam-framework] says "Out-of-band OAM is an active OAM whose path through the DetNet domain is not topologically identical to the path of the monitored DetNet flow, or its test packets receive different QoS and/or PREOF treatment, or both." [I-D.ietf-raw-architecture] uses similar text.
Combined: OAM in relation to multiple criteria. For example, in relation to both topological congruence and packet treatment.
[I-D.ietf-detnet-oam-framework] uses Combined OAM when it says "In-band OAM is an active OAM that is in-band within the monitored DetNet OAM domain when it traverses the same set of links and interfaces receiving the same QoS and Packet Replication, Elimination, and Ordering Functions (PREOF) treatment as the monitored DetNet flow". [I-D.ietf-raw-architecture] uses similar text.

Historical Uses
There are many examples of "in-band OAM" and "out-of-band OAM" in published RFCs. While interpreting those, it is important to understand the semantics of what "band" is a proxy for, and to be more explicit if those documents are updated. This document does not change the meaning of any terms in any prior RFCs.
For example, [RFC5085] says "as in-band traffic with the PW's data, or out-of-band", and "in-band (i.e., following the same data-plane faith as PW data)". Hence, in that specific case, the term "band" refers to the "Pseudowire data".

Active, Passive, Hybrid, and Compound OAM
[RFC7799] provides clear definitions for active and passive performance assessment such that the construction of metrics and methods can be described as either "Active" or "Passive". Even though [RFC7799] does not include the specific terms "Active", "Passive", or "Hybrid" as modifiers of "OAM", the following terms are used in many RFCs and are provided here for use in all future IETF documents that refer to OAM.
Active OAM:
Depends on dedicated, instrumented OAM packets.
Passive OAM:
Depends solely on the observation of one or more existing data packet streams and does not use dedicated OAM packets.
Hybrid OAM:
Uses instrumentation or modification of data packets themselves. [RFC9341] and [RFC9197] are examples labeled "Hybrid OAM" under this definition.
Compound OAM:
Uses a combination of at least two of Active OAM, Passive OAM, and Hybrid OAM (i.e., a combination of atomic OAM packets, data packet modification for OAM, and no explicit OAM). Note that [RFC7799] also uses the term "Hybrid" to refer to metric types in-between active and passive, for OAM there are no in-betweens per se, only active, passive, hybrid, or a compound combination.
Compound OAM can be characterized in a more explicit way, for nuanced use-cases:
  - Active-Passive OAM.
  - Active-Hybrid OAM.
  - Hybrid-Passive OAM.
  - Active-Hybrid-Passive OAM.
Note that [RFC7799] describes "passive methods" as "out of band" which is contrary to the concept of "Passive OAM" as defined here because there are no OAM packets to be in-band or out-of-band.
Following the guidelines of this document, OAM may be qualified according to the terms described in Sections 2 and 3 of this document, and the term "out of band OAM" is not to be used in future documents.

Extended OAM Abbreviations
This document recommends avoiding the creation and use of extended abbreviations for the qualifiers of "OAM". For example, the first "O" in "OOAM" could mean out-of-band, overlay, or something else.
[RFC9197] and other dependent documents currently uses the abbreviations "IOAM" for In situ Operations, Administration, and Maintenance (IOAM). While this document does not obsolete that abbreviation, it still recommends that the expanded "in situ OAM" is used instead to avoid potential ambiguity.

Processing of OAM Packets by Nodes
There are multiple processing capabilities that nodes processing OAM packets can utilize. Some of those capabilities are explained in [RFC9197] for in situ OAM and are further generalized in this document.
Depending on the Type of OAM processing, nodes are categorized as follows. Please note that this characterization exists within the context of a particular OAM protocol instance, and a given node can support multiple types.
Hybrid OAM instruments or modifies data packet themselves. Consequently:
  Encapsulating Node:
Adds OAM information to data packets.
  Transit Node:
May process OAM information in data packets.
  Transparent Node:
Does not process or even notice OAM information in data packets.
  Decapsulating Node:
Removes OAM information from data packets.
Active OAM uses dedicated OAM packets, separate from data packets. Consequently:
  OAM Source Node:
Creates and injects OAM packets into a flow.
  OAM Sink Node:
Processes and removes OAM packets from a flow.
A node could be an OAM Source Node and an OAM Sink Node for Active OAM packets simultaneously.
In some use-cases, such as in situ OAM described in [RFC9322], Compound OAM is used. In the forward direction, Hybrid OAM is used with a single Encapsulating Node. Multiple Transit Nodes may process the OAM information, and this may trigger them to act as OAM Source Nodes for Active OAM sent back to the Encapsulating Node which serves as an OAM Sink Node.

Security Considerations
Security is improved when terms are used with precision, and their definitions are unambiguous.

IANA Considerations
This document has no IANA actions.

Acknowledgements
The creation of this document was triggered when observing one of many on-mailing-list discussions of what these terms mean, and how to abbreviate them. Participants on that mailing thread include, alphabetically: Adrian Farrel, Alexander Vainshtein, Florian Kauer, Frank Brockners, Greg Mirsky, Italo Busi, Loa Andersson, Med Boucadair, Michael Richardson, Quan Xiong, Stewart Bryant, Tom Petch, Eduard Vasilenko, and Xiao Min.
The authors wish to thank, chronologically, Hesham Elbakoury, Michael Richardson, Stewart Bryant, Greg Mirsky, Med Boucadair, Loa Andersson, Thomas Graf, Alex Huang Feng, Xiao Min, Dhruv Dhody, Henk Birkholz, and Alex Huang Feng for their thorough review, supportive feedback, and useful comments that greatly improved this document.

Normative References

Informative References
[IETF96-In-Band-OAM]

IETF 96, OPSWG: In-Band OAM
Frank Brockners
Shwetha Bhandari
Sashank Dara
Carlos Pignataro
Hannes Gedler
Steve Youell
John Leddy
2016-07-19
IETF-96 Proceedings
IETF-96 slides-96-opsawg-8.pdf
[P4-INT-2.1]

In-band Network Telemetry (INT) Dataplane Specification, Version 2.1
The P4.org Applications Working Group
2020-11-11
[RFC6291]
[RFC7799]
[RFC4733]
[RFC6669]
[RFC8029]
[RFC9197]
[RFC9232]
[I-D.song-opsawg-ifit-framework]
[I-D.kumar-ippm-ifa]
[I-D.ietf-detnet-oam-framework]
[I-D.ietf-raw-architecture]
[RFC5085]
[RFC9341]
[RFC9322]